using System;
using System.Collections.Generic;
using System.Text;
using System.Data;

using iTextSharp;
using iTextSharp.text;
using iTextSharp.text.pdf;
using iTextSharp.text.factories;
 
using System.IO;
using System.Collections;
using System.Windows.Forms;
/*1
using PdfSharp.Drawing;
using PdfSharp.Pdf;
using PdfSharp.Pdf.IO;
using PdfSharp.Pdf.Advanced;
using PdfSharp.Pdf.Security;
*/

namespace PdfEncrypter
{
    class EncryptHelper
    {
        //PdfEncryptor.Encrypt(reader,myFileStream,PdfWriter.ENCRYPTION_RC4_128,sU 
        //Password,"test",PdfWriter.AllowPrinting|PdfWriter.AllowCopy); 

        public static string Title = "";
        public static string Author = "";
        public static string Subject = "";
        public static string Keywords = "";

        public static DateTime CreationDate = DateTime.Now;
        public static DateTime ModificationDate = DateTime.Now;
        public static string Creator = "";

        public static bool SetDocInfo = false;

        private static string DefaultPassword = "";

        public static string EncryptMultiplePDF(DataTable dt)
        {
            string err = "";

            for (int k = 0; k < dt.Rows.Count; k++)
            {
                string outfilepath="";
                string filepath=dt.Rows[k]["fullfilepath"].ToString();
                string password = dt.Rows[k]["userpassword"].ToString();

                if (frmMain.Instance.cmbOutputDir.Text.Trim() == TranslateHelper.Translate("Same Folder of PDF Document"))
                {
                    string dirpath = System.IO.Path.GetDirectoryName(filepath);
                    outfilepath = System.IO.Path.Combine(dirpath, System.IO.Path.GetFileNameWithoutExtension(filepath) + "_protected.pdf");
                }
                else if (frmMain.Instance.cmbOutputDir.Text.ToString().StartsWith(TranslateHelper.Translate("Subfolder") + " : "))
                {
                    int subfolderspos = (TranslateHelper.Translate("Subfolder") + " : ").Length;
                    string subfolder = frmMain.Instance.cmbOutputDir.Text.ToString().Substring(subfolderspos);

                    outfilepath = System.IO.Path.Combine(System.IO.Path.GetDirectoryName(filepath) + "\\" + subfolder, System.IO.Path.GetFileName(filepath));
                }
                else if (frmMain.Instance.cmbOutputDir.Text.Trim() == TranslateHelper.Translate("Overwrite PDF Document"))
                {
                    outfilepath = filepath;
                }
                else
                {
                    outfilepath = System.IO.Path.Combine(frmMain.Instance.cmbOutputDir.Text, System.IO.Path.GetFileName(filepath));
                }                                                

                try
                {
                    err += EncryptSinglePDF(filepath, outfilepath,password);
                }
                catch (Exception ex)
                {
                    err += ex.Message + "\r\n";
                }
            }

            return err;
        }

        /*1
        public static string EncryptSinglePDF(string InputFile, string OutputFile)
        {
            string err = "";

            try
            {
                // Open an existing document. Providing an unrequired password is ignored.
                PdfDocument document = PdfReader.Open(InputFile, "spooky");

                PdfSecuritySettings securitySettings = document.SecuritySettings;

                // Setting one of the passwords automatically sets the security level to 
                // PdfDocumentSecurityLevel.Encrypted128Bit.

                if (frmMain.Instance.txtUserPassword.Text.Trim() != string.Empty)
                {
                    securitySettings.UserPassword = frmMain.Instance.txtUserPassword.Text;
                }

                if (frmMain.Instance.txtOwnerPassword.Text.Trim() != string.Empty)
                {
                    securitySettings.OwnerPassword = frmMain.Instance.txtOwnerPassword.Text;
                }

                // Don't use 40 bit encryption unless needed for compatibility
                if (frmMain.Instance.rd40Bits.Checked)
                {
                    securitySettings.DocumentSecurityLevel = PdfDocumentSecurityLevel.Encrypted40Bit;
                }

                // Restrict some rights.
                securitySettings.PermitAccessibilityExtractContent = frmMain.Instance.chkScreenReaders.Checked;
                securitySettings.PermitAnnotations = frmMain.Instance.chkAnnotations.Checked;
                securitySettings.PermitAssembleDocument = frmMain.Instance.chkAssembly.Checked;
                securitySettings.PermitExtractContent = frmMain.Instance.chkCopy.Checked;
                securitySettings.PermitFormsFill = frmMain.Instance.chkFormFill.Checked;
                securitySettings.PermitFullQualityPrint = frmMain.Instance.chkHighPrinting.Checked;
                securitySettings.PermitModifyDocument = frmMain.Instance.chkModifyContents.Checked;
                securitySettings.PermitPrint = frmMain.Instance.chkLowPrinting.Checked;

                if (frmDocumentInfo.Instance.chkAuthor.Checked)
                {
                    document.Info.Author = Author;
                }
                if (frmDocumentInfo.Instance.chkCreator.Checked)
                {
                    document.Info.Creator = Creator;
                }
                if (frmDocumentInfo.Instance.chkKeywords.Checked)
                {
                    document.Info.Keywords = Keywords;
                }

                if (frmDocumentInfo.Instance.chkModificationDate.Checked)
                {
                    document.Info.ModificationDate = ModificationDate;
                }

                if (frmDocumentInfo.Instance.chkCreationDate.Checked)
                {
                    document.Info.CreationDate = CreationDate;
                }

                if (frmDocumentInfo.Instance.chkTitle.Checked)
                {
                    document.Info.Title = Title;
                }

                if (frmDocumentInfo.Instance.chkSubject.Checked)
                {
                    document.Info.Subject = Subject;
                }                                

                // Save the document...
                document.Save(OutputFile);
                
                /*
                            if (SetDocInfo)
                            {
                                Dictionary<string, string> dict = new Dictionary<string, string>();
                                dict.Add("Author", Author);
                                dict.Add("Subject", Subject);
                                dict.Add("Keywords", Keywords);
                                dict.Add("Title", Title);

                                PdfEncryptor.Encrypt(reader, output, strength, userp, ownerp, permissions, dict);
                            }
                            else
                            {
                                PdfEncryptor.Encrypt(reader, output, strength, userp, ownerp, permissions);
                            }
                        }
                 */                             
        /*1
            }
            catch (Exception ex)
            {
                err += ex.Message;
            }

            return err;
        }
        */
        public static string EncryptSinglePDF(string InputFile, string OutputFile,string Password)
        {
            string err = "";

            try
            {
                //                using (FileStream input = new FileStream(InputFile, FileMode.Open, FileAccess.Read, FileShare.Read))
                //{
                PdfReader reader = null;

                if (!System.IO.Directory.Exists(System.IO.Path.GetDirectoryName(OutputFile)))
                {
                    try
                    {
                        System.IO.Directory.CreateDirectory(System.IO.Path.GetDirectoryName(OutputFile));
                    }
                    catch (Exception exd)
                    {
                        err += TranslateHelper.Translate("Error. Could not Create Directory for File") + " : " + InputFile+"\r\n"+exd.Message+"\r\n";
                        return err;
                    }
                }


                try
                {
                    //  reader = new PdfReader(input);

                    while (true)
                    {
                        using (Stream input = new FileStream(InputFile, FileMode.Open, FileAccess.Read, FileShare.Read))
                        {
                            try
                            {
                                if (!String.IsNullOrEmpty(Password))
                                {
                                    reader = new PdfReader(input, Encoding.Default.GetBytes(Password));
                                    //reader = new PdfReader(input, Encoding.UTF8.GetBytes(Password));

                                }
                                else
                                {
                                    reader = new PdfReader(input);
                                }

                                break;
                            }
                            catch (iTextSharp.text.pdf.BadPasswordException ex)
                            {
                                if (reader != null)
                                {
                                    reader.Close();
                                }

                                if (input != null)
                                {
                                    input.Close();
                                }

                                //frmMain.Instance.backgroundWorker1.CancelAsync();

                                //while (frmMain.Instance.backgroundWorker1.IsBusy)
                                //{
                                //Application.DoEvents();
                                //}

                                if (string.IsNullOrEmpty(Password) && !string.IsNullOrEmpty(DefaultPassword))
                                {
                                    Password = DefaultPassword;
                                }
                                else
                                {
                                    frmProgress.Instance.HideForm();

                                    Module.ShowMessage("Please enter the correct User Password !");

                                    frmPassword f2 = new frmPassword(InputFile);

                                    

                                    DialogResult dres = f2.ShowDialog();

                                    frmProgress.Instance.ShowForm();

                                    //frmMain.Instance.backgroundWorker1.RunWorkerAsync();

                                    if (dres == DialogResult.OK)
                                    {
                                        Password = f2.txtPassword.Text;

                                        if (f2.chkPassword.Checked)
                                        {
                                            DefaultPassword = Password;
                                        }

                                    }
                                    else
                                    {
                                        err += TranslateHelper.Translate("Error. Wrong User Password for File") + " : " + InputFile;
                                        return err;
                                    }
                                }
                            }
                        }
                    }

                    string userp = frmMain.Instance.txtUserPassword.Text;
                    if (userp == "")
                    {
                        userp = null;
                    }

                    string ownerp = frmMain.Instance.txtOwnerPassword.Text;
                    if (ownerp == "")
                    {
                        ownerp = null;
                    }

                    Dictionary<string, string> dict = new Dictionary<string, string>();
                    //PdfDictionary dict = new PdfDictionary();

                    if (frmDocumentInfo.Instance.chkAuthor.Checked)
                    {
                        dict.Add("Author", Author);
                    }
                    if (frmDocumentInfo.Instance.chkCreator.Checked)
                    {
                        dict.Add("Creator", Creator);
                    }
                    if (frmDocumentInfo.Instance.chkKeywords.Checked)
                    {
                        dict.Add("Keywords", Keywords);
                    }

                    if (frmDocumentInfo.Instance.chkModificationDate.Checked)
                    {
                        //dict.Add("ModificationDate", ModificationDate.ToString());
                        //dict.Add("ModDate", new PdfDate(ModificationDate).ToString());
                        dict.Add(PdfName.MODDATE.ToString(), new PdfDate(ModificationDate).ToString());
                    }

                    if (frmDocumentInfo.Instance.chkCreationDate.Checked)
                    {
                        dict.Add("CreationDate", new PdfDate(CreationDate).ToString());
                    }

                    if (frmDocumentInfo.Instance.chkTitle.Checked)
                    {
                        dict.Add("Title", Title);
                    }

                    if (frmDocumentInfo.Instance.chkSubject.Checked)
                    {
                        dict.Add("Subject", Subject);
                    }

                    string TmpFile = "";

                    if (frmMain.Instance.cmbOutputDir.Text == TranslateHelper.Translate("Overwrite PDF Document"))
                    {
                        TmpFile = OutputFile;
                        OutputFile = System.IO.Path.GetTempFileName();
                    }
                    
                    if (ownerp == null && userp == null)
                    {
                        using (MemoryStream memoryStream = new MemoryStream())
                        {
                            PdfStamper stamper = new PdfStamper(reader, memoryStream);
                            if (dict.Count > 0)
                            {
                                stamper.MoreInfo = dict;
                            }

                            stamper.Close();
                            reader.Close();

                            File.WriteAllBytes(OutputFile, memoryStream.ToArray());
                        }

                        if (TmpFile != string.Empty)
                        {
                            System.IO.File.Delete(TmpFile);
                            System.IO.File.Move(OutputFile, TmpFile);
                        }

                        return err;
                    }

                    using (Stream output = new FileStream(OutputFile, FileMode.Create, FileAccess.Write, FileShare.None))
                    {
                        int permissions = 0;
                        if (frmMain.Instance.chkAnnotations.Checked)
                        {
                            permissions |= PdfWriter.ALLOW_MODIFY_ANNOTATIONS;
                        }

                        if (frmMain.Instance.chkAssembly.Checked)
                        {
                            permissions |= PdfWriter.ALLOW_ASSEMBLY;
                        }

                        if (frmMain.Instance.chkCopy.Checked)
                        {
                            permissions |= PdfWriter.ALLOW_COPY;
                        }

                        if (frmMain.Instance.chkFormFill.Checked)
                        {
                            permissions |= PdfWriter.ALLOW_FILL_IN;
                        }

                        if (frmMain.Instance.chkHighPrinting.Checked)
                        {
                            permissions |= PdfWriter.ALLOW_PRINTING;
                        }

                        if (frmMain.Instance.chkLowPrinting.Checked)
                        {
                            permissions |= PdfWriter.ALLOW_DEGRADED_PRINTING;
                        }

                        if (frmMain.Instance.chkModifyContents.Checked)
                        {
                            permissions |= PdfWriter.ALLOW_MODIFY_CONTENTS;
                        }

                        if (frmMain.Instance.chkScreenReaders.Checked)
                        {
                            permissions |= PdfWriter.ALLOW_SCREENREADERS;
                        }

                        bool strength = frmMain.Instance.rd128Bits.Checked;

                        //if (SetDocInfo)
                        //{                                               

                        if (dict.Count > 0)
                        {
                            PdfEncryptor.Encrypt(reader, output, strength, userp, ownerp, permissions, dict);
                        }
                        else
                        {
                            PdfEncryptor.Encrypt(reader, output, strength, userp, ownerp, permissions);
                        }
                    }

                    if (TmpFile != string.Empty)
                    {
                        System.IO.File.Delete(TmpFile);
                        System.IO.File.Move(OutputFile, TmpFile);
                    }
                }
                catch (Exception exm)
                {
                    err += TranslateHelper.Translate("An error occured while protecting PDF File") + " : " + InputFile + "\r\n" + exm.Message + "\r\n";
                }
                finally
                {
                    if (reader != null)
                    {
                        reader.Close();
                    }
                }
            }
            catch (Exception ex)
            {
                err += TranslateHelper.Translate("An error occured while protecting PDF File") + " : " + InputFile + "\r\n" + ex.Message + "\r\n";
            }

            return err;
        }
    }
}
